; Parse the command line arguments for argument number ax (ax = 1 corresponds
; to the first argument). The ax'th argument is copied to the buffer ES:DI,
; and terminated with 0. If there are insufficient arguments the carry flag
; is set and nothing is done.

GetArg		PROC	NEAR

		push	ax bx si di

		mov	bx, ax			; store argument number
		mov	si, PSP_arg
		cld


get_arg_loop:
		lodsb
		cmp	al, 0dh			; end of arg list
		jz	get_arg_fail
		cmp	al, 20h			; space
		jz	get_arg_loop
		cmp	al, 9			; tab
		jz	get_arg_loop
		dec	bx
		jz	extract_arg

skip_non_ws:
		lodsb
		cmp	al, 0dh
		jz	get_arg_fail
		cmp	al, 20h
		jz	get_arg_loop
		cmp	al, 9
		jz	get_arg_loop
		jmp	skip_non_ws

get_arg_fail:
		pop	di si bx ax
		stc				; set carry flag to indicate error
		ret

extract_arg_loop:
		lodsb
extract_arg:
		cmp	al, 0dh
		jz	extract_arg_done
		cmp	al, 20h
		jz	extract_arg_done
		cmp	al, 9
		jz	extract_arg_done
		stosb				; copy the argument to ES:DI
		jmp	extract_arg_loop

extract_arg_done:
		xor	ax, ax
		stosb				; terminated with 0
		pop	di si bx ax
		ret

GetArg		ENDP

PSP_arg		equ 81h
