; Read in a password and return two 'magic' numbers based on some calculation 
; of the password.
; The two values are returned in ax and bx.
; A shifted sum/xor of all the characters is returned in cx, useful for a
; checksum to print out "wrong password".

ReadPasswd	PROC NEAR
		push dx

		xor bx, bx
		xor cx, cx
		xor dx, dx

next_char:
		xor ah, ah			; read character
		int 16h				; from keyboard
		cmp al, 0dh			; enter/return -> done
		jz read_passwd_done

		xor ah, ah			; discard scancode
		add ch, al
		ror ch, 1			; ch stores shifted sum
		xor cl, al			; cl stores xor of password
		add dx, ax			; dx stores sum
		imul dl
		mov bx, ax			; bx stores product of sums
		jmp next_char

read_passwd_done:
		mov ax, dx			; ax now stores sum
		pop dx
		ret

ReadPasswd	ENDP
