;
; An XOR-with-0xff loader.
; "num_bytes" from "data" onwards are XORed with 0xff, then executed.
; Typical use is to compile to a COM file, then append size of a host program
; followed by an XORed version of the program.
; The program FFMAKE.ASM does this.
;
; Copyright           ztank August 1998
;

.model tiny

code		segment
		assume cs:code, ds:code
		org 100h
prog_start:
		cld
		mov si, offset relocator
		mov di, offset data
		add di, word ptr [num_bytes]	; work out location after encrypted data
		mov ax, di			; store relocator location
		mov cx, relocator_size
		rep movsb
		mov si, offset data		; tell relocator where to find data DS:SI
		mov di, 0100h			; move it to here ES:DI
		mov cx, word ptr [num_bytes]
		jmp ax				; jump to relocator

relocator	equ $
		push cx
		rep movsb
		pop cx

		; decryption time...
		mov si, 0100h

next_byte:
		xor byte ptr [si], 0ffh
		inc si
		loop next_byte

		; jump back		
		mov si, 0100h
		jmp si

relocator_size	equ $ - relocator
num_bytes	equ $
data		equ $ + 2

code		ends

end prog_start

