;
; Loader for a password protected file. A file encrypted with ENCRYPT.ASM can
; be executed with this loader. Just concatenate the result from ENCRYPT.ASM
; to PASSLDR.COM.
;
; Copyright           ztank August 1998
;

.model tiny

code		segment
		assume cs:code, ds:code
		org 100h

		
prog_start:
		cld

		; ask user for password
		mov	si, offset prompt
		call	PrintStr

		call	ReadPasswd
		cmp	cx, word ptr [checksum]
		jz	pass_ok

		mov	si, offset mesg_fail
		call	PrintStr

prog_exit:
		mov	ax, 04c00h
		int	21h

pass_ok:
		; print newline (after password)
		push	ax
		push	bx
		mov	ax, 00e0ah
		xor	bx, bx
		int	10h
		mov	al, 0dh
		int	10h
		pop	bx
		pop	ax

		; now to decrypt the rest of the code using ax, bx
		mov	cx, word ptr [num_bytes]
		mov	si, offset data
		call	Encrypt

		; mov the relocation code
		mov	di, offset data
		add	di, word ptr [num_bytes]	; di -> after encryped data
		mov	si, offset relocate_code
		mov	cx, relocate_code_size
		rep	movsb			; move the relocation code
		sub	di, relocate_code_size
		jmp	di				; execute it

;------------------------------------------------------------------------------

include		Encrypt.inc

;------------------------------------------------------------------------------

include		PrintStr.inc
include		ReadPass.inc

;-----------------------------------------------------------------------------

relocate_code	equ $
		; move the encrypted code to offset 100
		mov	si, offset data		; si -> start of encrypted
		mov	cx, word ptr [num_bytes]
		mov	di, 0100h
		rep	movsb			; move the bytes
		mov	si, 0100h
		jmp	si			; execute
relocate_code_size	equ $ - relocate_code

mesg_fail	db 10,13,"Password Authentication FAILED!",10,13,0
prompt		db "Enter password:",0

encrypt_block	equ $
checksum	equ $ + 0
num_bytes	equ $ + 2
data		equ $ + 4

code		ends

end prog_start
